#Include "windows.bi"
#Include "win/gdiplus.bi"
Using GDIPLUS
Dim wc As WNDCLASSEX
Dim  msg As MSG
Dim ULONG_PTR_01 As ULONG_PTR
Dim GDIPLUSSTARTUPINPUT_01 As GDIPLUSSTARTUPINPUT
GDIPLUSSTARTUPINPUT_01.GdiplusVersion = 1
If (GdiplusStartup(@ULONG_PTR_01, @GDIPLUSSTARTUPINPUT_01, NULL) <> 0) Then
	Print "FAIL"
EndIf
Function Load_image(ByVal Image As String) As Any Ptr
	Dim GPIMAGE_01 As GPBITMAP Ptr
	Var blen = (Len(Image)*2)+2
	Dim As WString Ptr wbuf
	wbuf  = Allocate( blen )
	MultiByteToWideChar(CP_ACP, 0, Image, -1, wbuf, blen)
	If (GdipLoadImageFromFile( *wbuf, @GPIMAGE_01) <> 0) Then
		Print "FAIL"
	End If
	DeAllocate(wbuf)
	Return GPIMAGE_01
End Function
Function WndProc(hWnd As HWND,uMsg As UINT,wParam As WPARAM,lParam As LPARAM) As Integer
	Dim ps As PAINTSTRUCT
	Static As HDC compHdc,hdc
	Select Case uMsg
		Case WM_CLOSE
			DeleteDC(compHdc)
			PostQuitMessage(0)
		Case WM_CREATE
			Dim GpGraphics As PVOID
			Dim pen As PVOID
			Dim GDIbitmap As PVOID
			Dim As Integer w,h,row,column
			Dim As ARGB color_,colortemp
			hdc=GetDC(GetDesktopWindow)
			compHdc=CreateCompatibleDC(hdc)
			Var bitmap = CreateCompatibleBitmap(hdc,GetSystemMetrics(SM_CXSCREEN),GetSystemMetrics(SM_CYSCREEN))
			SelectObject(compHdc,bitmap)
			DeleteObject(bitmap)
			ReleaseDC(GetDesktopWindow,hdc)
			GDIbitmap=Load_image("..\Media\Texture1.jpg")
			GdipCreateFromHDC(compHdc,@GpGraphics)
			GdipGetImageWidth(GDIbitmap,@w)
			GdipGetImageHeight(GDIbitmap,@h)
			for Row = 0 to h - 1
				for Column = 0 to w - 1
					GdipBitmapGetPixel(GDIbitmap,column,row,@color_)
					colortemp=RGBA(GetBValue(color_),GetGValue(color_),GetRValue(color_),255 * Column \ w)
					GdipBitmapSetPixel(GDIbitmap,column,row,Cast(ARGB,colortemp))
				Next
			Next
			GdipCreatePen1(&hFFffffff,25,Unitpixel,@pen)
			GdipDrawLine(GpGraphics,pen , 10, 35, 200, 35)
			GdipDrawImage(GpGraphics,GDIbitmap,30,0)
			GdipDeletePen(pen)
			GdipDisposeImage(GDIbitmap)
			GdipDeleteGraphics(GpGraphics)
			InvalidateRect(hwnd,0,0)
		Case WM_PAINT
			BeginPaint(hWnd,@ps)
			BitBlt(ps.hdc,ps.rcPaint.left,ps.rcPaint.top,ps.rcPaint.right-ps.rcPaint.left,ps.rcPaint.bottom-ps.rcPaint.top,compHdc,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY)
			EndPaint(hWnd,@ps)
			Return 0
		Case Else
			Return DefWindowProc(hWnd,uMsg,wParam,lParam)
	End Select
End Function

With wc
	.hInstance=GetModuleHandle(0)
	.cbSize=SizeOf(WNDCLASSEX)
	.style=CS_HREDRAW Or CS_VREDRAW
	.lpfnWndProc=@WndProc
	.lpszClassName=StrPtr("class")
	.hCursor=LoadCursor(NULL,IDC_ARROW)
End With
RegisterClassEx(@wc)
CreateWindowEx(0,wc.lpszClassName,"DrawGDI+",WS_OVERLAPPEDWINDOW Or WS_VISIBLE,200,200,230,120,0,0,wc.hInstance,0)

While GetMessage(@msg,0,0,0)
	TranslateMessage(@msg)
	DispatchMessage(@msg)
Wend