#INCLUDE "windows.bi"
#INCLUDE "win/gdiplus.bi"
Using GDIPLUS
Dim wc As WNDCLASSEX
Dim  msg As MSG
Dim ULONG_PTR_01 As ULONG_PTR
Dim GDIPLUSSTARTUPINPUT_01 As GDIPLUSSTARTUPINPUT
GDIPLUSSTARTUPINPUT_01.GdiplusVersion = 1
If (GDIPLUSSTARTUP(@ULONG_PTR_01, @GDIPLUSSTARTUPINPUT_01, NULL) <> 0) Then
	Print "FAIL"
EndIf
Type ColMatrix
	 As Single m(4,4)={_
	 {1.0,0.0,0.0,0.0,0.0},_
	 {0.0,1.0,0.0,0.0,0.0},_
	 {0.0,0.0,1.0,0.0,0.0},_
	 {0.0,0.0,0.0,0.8,0.0},_
	 {0.0,0.0,0.0,0.0,1.0}}
End Type
Function Load_image(byval Image as String) as Any Ptr
	DIM GPIMAGE_01 AS GPBITMAP PTR
	Var blen = (Len(Image)*2)+2
	Dim As WString Ptr wbuf
	wbuf  = Allocate( blen )
	MultiByteToWideChar(CP_ACP, 0, Image, -1, wbuf, blen)
	IF (GDIPLOADIMAGEFROMFILE( *wbuf, @GPIMAGE_01) <> 0) THEN
		PRINT "FAIL"
	End If
	DeAllocate(wbuf)
	Return GPIMAGE_01
end Function
Function WndProc(hWnd As HWND,uMsg As UINT,wParam As WPARAM,lParam As LPARAM) As Integer
	Dim ps As PAINTSTRUCT
	Static As HDC compHdc,hdc
	Select Case uMsg
		Case WM_CLOSE
			DeleteDC(compHdc)
			PostQuitMessage(0)
		Case WM_CREATE
			Dim GpGraphics As PVOID
			Dim pen As PVOID
			Dim GDIbitmap As PVOID
			Dim imageAtt As PVOID
			Dim As ColMatrix ColorMatrix			
			Dim As Integer w,h
			hdc=GetDC(GetDesktopWindow)
			compHdc=CreateCompatibleDC(hdc)
			Var bitmap = CreateCompatibleBitmap(hdc,GetSystemMetrics(SM_CXSCREEN),GetSystemMetrics(SM_CYSCREEN))
			SelectObject(compHdc,bitmap)
			DeleteObject(bitmap)
			ReleaseDC(GetDesktopWindow,hdc)
			GDIbitmap=Load_image("..\Media\Texture1.jpg")
			GdipGetImageWidth(GDIbitmap,@w)
			GdipGetImageHeight(GDIbitmap,@h)
			GdipCreateFromHDC(compHdc,@GpGraphics)
			GdipCreatePen1(&hfff00000,25,Unitpixel,@pen)
			GdipDrawLine(GpGraphics,pen , 10, 35, 200, 35)
			GdipDrawImageRect(GpGraphics,GDIbitmap,30,0,w,h)
			GdipCreateImageAttributes(@imageAtt)
			GdipSetImageAttributesColorMatrix(imageAtt,ColorAdjustTypeBitmap,TRUE,Cast(Any ptr,@ColorMatrix),0,ColorMatrixFlagsDefault)
			GdipDrawLine(GpGraphics,pen , 10, 35+h, 200, 35+h)
			GdipDrawImageRectRect(GpGraphics,GDIbitmap,30,h,w,h,0,0,w,h,UnitPixel,imageAtt,0,0)
			GdipDeletePen(pen)
			GdipDisposeImageAttributes(imageAtt)
			GdipDisposeImage(GDIbitmap)
			GdipDeleteGraphics(GpGraphics)
			InvalidateRect(hwnd,0,0)
		Case WM_PAINT
			BeginPaint(hWnd,@ps)
			BitBlt(ps.hdc,ps.rcPaint.left,ps.rcPaint.top,ps.rcPaint.right-ps.rcPaint.left,ps.rcPaint.bottom-ps.rcPaint.top,compHdc,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY)
			EndPaint(hWnd,@ps)
			Return 0
		Case Else
			Return DefWindowProc(hWnd,uMsg,wParam,lParam)
	End Select
End Function

With wc
	.hInstance=GetModuleHandle(0)
	.cbSize=SizeOf(WNDCLASSEX)
	.style=CS_HREDRAW Or CS_VREDRAW
	.lpfnWndProc=@WndProc
	.lpszClassName=StrPtr("class")
	.hCursor=LoadCursor(NULL,IDC_ARROW)
End With
RegisterClassEx(@wc)
CreateWindowEx(0,wc.lpszClassName,"DrawGDI+",WS_OVERLAPPEDWINDOW Or WS_VISIBLE,200,200,230,210,0,0,wc.hInstance,0)

While GetMessage(@msg,0,0,0)
	TranslateMessage(@msg)
	DispatchMessage(@msg)
Wend